$ ! ADDNEWS.COM - by Timothy Russell
$ !---------------------------------+------------------------------------------
$ ! Tim Russell, Computer Operator  | Internet: russell%zeus@fergvax.unl.edu
$ ! Campus Computing                | Bitnet:   russell@unoma1
$ ! University of Nebraska at Omaha | UUCP:     uunet!zeus.unl.edu!russell
$ !---------------------------------+------------------------------------------
$ !
$ !	This procedure runs from a batch queue periodically, adding
$ ! items from mailing lists into the appropriate NEWS newsgroups.
$ ! To add a group, simply add it to the string GROUPS_1, and overflow
$ ! to GROUPS_2, etc, since strings can only go up to 255 characters.
$ ! If you add a new string, be sure to update NUMGRPSTR as well.
$ !
$ !	This procedure creates two temporary command procedures, one
$ ! to go into MAIL and extract the items into seperate batch files
$ ! for each list, and another to add only those groups that actually
$ ! had items on this pass into NEWS.
$ !
$ !	You can search for *CHANGE* to find things that need to be
$ ! modified for your site's configuration.
$ !
$ !	NOTE: This is for VMS 5.0 MAIL only.
$ !**********************************************************************
$ !
$   set output_rate=:0:10
$ !
$ !	Define Bitnet lists to process
$ !
$ !	*CHANGE* Number of strings of list names
$ !
$   numgrpstr = 1
$ !
$ !	*CHANGE* Groups to process, in strings GROUPS_x, seperated by commas
$ !
$   groups_1 = "ICON-GROUP,ANU-NEWS,SPSSX-L,SAS-L,JNET-L,CCNEWS,NETMONTH"
$ !
$ !     Start
$ !
$   on error then goto abort
$ !
$ !**********************************************************************
$ !     Create temporary command file to extract lists from MAIL
$ !
$    open/write exttmp exttmp.com
$    write exttmp "$mail"
$    grpstr = 0
$ ext_nextstr:
$    grpstr = grpstr + 1
$    index = 0
$ ext_process:
$    thislist = f$element(index,",",groups_'grpstr')
$    if thislist .eqs. "," then goto ext_nomore
$    write exttmp "select newmail"
$    write exttmp "select/to=" + thislist
$    write exttmp "extract/all " + thislist + ".batch"
$    write exttmp "delete/all"
$    index = index + 1
$    goto ext_process
$ ext_nomore:
$    if grpstr .nes. numgrpstr then goto ext_nextstr
$    write exttmp "purge"
$    write exttmp "exit"
$    close exttmp
$    @exttmp
$ !
$ !	Create temporary command file to add batches into NEWS
$ !
$    open/write addtmp addtmp.com
$    write addtmp "$news/noscreen"
$    gotbatch = 0
$    grpstr = 0
$ add_nextstr:
$    grpstr = grpstr + 1
$    index = 0
$ add_process:
$    thislist = f$element(index,",",groups_'grpstr')
$    if thislist .eqs. "," then goto add_nomore
$ ! *CHANGE* Change after "/defnews=" to correspond to your
$ !	     bitnet newsgroup naming conventions - ours are "net.listname"
$    if f$search(thislist + ".batch") .nes. ""
$    then
$       write addtmp "add batch/delete/defnews=net." + thislist -
           + " " + thislist + ".batch"
$       gotbatch = 1
$    endif
$    index = index + 1
$    goto add_process
$ add_nomore:
$    if grpstr .nes. numgrpstr then goto add_nextstr
$    write addtmp "exit"
$    close addtmp
$    if gotbatch .eqs. 1 then @addtmp
$ !
$ !**********************************************************************
$ !      Completed
$ !
$ resubmit:
$ ! *CHANGE* Interval between runs
$    submit/noprint/after="+1"/queue=news$batch addnews.com
$ abort:
$    set noon
$    delete/noconfirm/nolog exttmp.com;
$    delete/noconfirm/nolog addtmp.com;
